#include <Application.h>
#include <midi/MidiSynth.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main(int argc, char** argv)
{
	BApplication app("application/x-bweb-midi1");
	BMidiSynth midiSynth;
	int* notes;
	int* thirds;
	int* sevenths;
	notes=thirds=sevenths=NULL;
	int len=0;
	int tlen=1200000;
	int x,nval,tval,sval,bval,oldbval;
	int repeat=0;
	int first;
	int bpm=0;
	if (argc<2) {
		printf("Usage: %s filename [-repeat] [bpm]\n",argv[0]);
		return 0;
	}
	if (argc>2) if (strcmp(argv[2],"-repeat")==0) repeat=1;
	if ((argc==3 && !repeat) || argc==4) {
		if (argc==3) sscanf(argv[2],"%d",&bpm);
		else sscanf(argv[3],"%d",&bpm);
		if (bpm==0) return 0;
		tlen=60000000/bpm;
	}
	if (repeat) fprintf(stderr,"Repeat is on.\n");
	if (argc==4 && !repeat) return 0;
	FILE* inc=fopen(argv[1],"r");
	char c;
	c=fgetc(inc);
	while (c!=EOF && inc) {
		int k;
		len++;
		notes=(int*) realloc(notes,len*sizeof(int));
		thirds=(int*) realloc(thirds,len*sizeof(int));
		sevenths=(int*) realloc(sevenths,len*sizeof(int));
		if (c<'A' || c>'G')
			return 0;
		c-='C';
		k=c; /* k should be between 0 and 6 now */
		if (k==0) k=0;
		else if (k==1) k=2;
		else if (k==2) k=4;
		else if (k==3) k=5;
		else if (k==4) k=7;
		else if (k==-2) k=9;
		else if (k==-1) k=11;
		c=fgetc(inc);
		if (c!='\t')
			return 0;
		c=fgetc(inc);
		if (c=='-') k-=1;
		else if (c=='+') k+=1;
		else if (c==' ');
		else
			return 0;
		notes[x]=k;
		c=fgetc(inc);
		if (c!='\t')
			return 0;
		c=fgetc(inc);
		if (c=='M') thirds[x]=notes[x]+4;
		else if (c=='m') thirds[x]=notes[x]+3;
		c=fgetc(inc);
		if (c!='\t')
			return 0;
		c=fgetc(inc);
		if (c=='M') sevenths[x]=notes[x]+11;
		else if (c=='m') sevenths[x]=notes[x]+10;
		c=fgetc(inc);
		if (c!='\n')
			return 0;
		c=fgetc(inc);
		x++;
	}
	/* Enable input, and load the synth file. */
	midiSynth.EnableInput(true, true);
	/* Associate the instrument with a MIDI channel. */
	midiSynth.ProgramChange(1, B_ACOUSTIC_GRAND);
	midiSynth.ProgramChange(2, B_VIBRAPHONE);
	midiSynth.ProgramChange(3, B_ACOUSTIC_BASS);
	midiSynth.SetVolume(1.50);
	/* Play. */
	first=1;
	while (first || repeat) {
		for (x=0;x<len;x++) {
			nval=48+notes[x];
			tval=48+thirds[x];
			sval=48+sevenths[x];
			bval=nval-12;
			midiSynth.NoteOn(1, nval, 100);
			midiSynth.NoteOn(3, bval, 100);
			snooze(tlen/2);
			midiSynth.NoteOff(1, nval, 100);
			midiSynth.NoteOn(1, sval, 100);
			midiSynth.NoteOn(2, nval+24, 100);
			midiSynth.NoteOn(2, tval+24, 100);
			snooze(tlen/4);
			midiSynth.NoteOff(1, sval, 100);
			midiSynth.NoteOn(1, nval, 100);
			snooze(tlen/4);
			midiSynth.NoteOff(1, nval, 100);
			midiSynth.NoteOff(2, nval+24, 100);
			midiSynth.NoteOff(2, tval+24, 100);
			x++;
			oldbval=bval;
			if (x<len) {
				nval=48+notes[x];
				tval=48+thirds[x];
				sval=48+sevenths[x];
			}
			bval=sval-12;
			midiSynth.NoteOn(1, nval, 100);
			snooze(tlen/2);
			midiSynth.NoteOff(1, nval, 100);
			midiSynth.NoteOff(3, oldbval, 100);
			midiSynth.NoteOn(3, bval, 100);
			midiSynth.NoteOn(1, sval, 100);
			midiSynth.NoteOn(2, nval+24, 100);
			midiSynth.NoteOn(2, tval+24, 100);
			snooze(tlen/2);
			midiSynth.NoteOff(1, sval, 100);
			midiSynth.NoteOff(2, nval+24, 100);
			midiSynth.NoteOff(2, tval+24, 100);
			midiSynth.NoteOff(3, bval, 100);
		}
		first=0;
	}
}
